=== modified file 'bzrlib/bundle/serializer/v08.py'
--- bzrlib/bundle/serializer/v08.py	2006-09-21 22:02:58 +0000
+++ bzrlib/bundle/serializer/v08.py	2006-09-22 02:08:10 +0000
@@ -95,9 +95,8 @@
         return BundleReader(f).info
 
     def check_compatible(self):
-        if self.source._format.rich_root_data:
-            raise errors.IncompatibleFormat('0.8', 
-                self.source._format.get_format_description())
+        if self.source.supports_rich_root():
+            raise errors.IncompatibleFormat('0.8', repr(self.source))
 
     def write(self, source, revision_ids, forced_bases, f):
         """Write the bundless to the supplied files.

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2006-09-22 01:05:30 +0000
+++ bzrlib/repository.py	2006-09-22 02:08:10 +0000
@@ -709,6 +709,9 @@
         warning("Format %s for %s is deprecated - please use 'bzr upgrade' to get better performance"
                 % (self._format, self.bzrdir.transport.base))
 
+    def supports_rich_root(self):
+        return self._format.rich_root_data
+
 
 class AllInOneRepository(Repository):
     """Legacy support - the repository behaviour for all-in-one branches."""
@@ -779,11 +782,10 @@
     inv = revision_tree.inventory
     entries = inv.iter_entries()
     # backwards compatability hack: skip the root id.
-    if not repository._format.rich_root_data:
+    if not repository.supports_rich_root():
         path, root = entries.next()
         if root.revision != rev.revision_id:
-            raise errors.IncompatibleRevision(
-                repository._format.get_format_description())
+            raise errors.IncompatibleRevision(repr(repository))
     # Add the texts that are not already present
     for path, ie in entries:
         w = repository.weave_store.get_weave_or_empty(ie.file_id,

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2006-09-15 01:21:38 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2006-09-22 02:08:10 +0000
@@ -71,6 +71,15 @@
         tree_b.get_file_text('file1')
         rev1 = repo_b.get_revision('rev1')
 
+    def test_supports_rich_root(self):
+        tree = self.make_branch_and_tree('a')
+        tree.commit('')
+        second_revision = tree.commit('')
+        inv = tree.branch.repository.revision_tree(second_revision).inventory
+        rich_root = (inv.root.revision != second_revision)
+        self.assertEqual(rich_root, 
+                         tree.branch.repository.supports_rich_root())
+
     def test_clone_specific_format(self):
         """todo"""
 

